% Matthew Gentzkow
% June 24, 2002
%
% function choosefromv
%
% Takes a vector of dummy variables as input, randomly chooses a specified number
% of elements, and returns a new vector with the chosen elements=1 and all other
% elements =0.
%
% Note it is written right now for ROW VECTORS for both input and output.

function newv = choosefromv(n,v);

if max(v)>1 | min(v)<0, error('choosefromv only takes 0-1 vectors as input'); end

size=length(v);
draws = rand(1,size);
draws = draws.*v;
newv = zeros(1,size);
for i = 1:n
    [xx,index]=max(draws);
    draws(index)=0;
    newv(index)=1;
end