% Matthew Gentzkow
% February 14, 2002
%
% function simulate
%
% Simulates t choices using probabilities given in probmat
% and reports fractions of each choice. 

function [result,shares] = simulate(probmat,t)

s = size(probmat);
n = s(1);		% number of rows
c = s(2);		% number of choices

result = zeros(n,t);

for i = 1:t
   result(:,i) = chooseone(probmat);
end

edges = cumsum(ones(c,1));
result = reshape(result,n*t,1);
count = histc(result,edges);
if n == 1, count = count'; end
shares = count./repmat(sum(count),c,1);