% testlogit
%
% simulations to test random utility model for multiple choices

function [dist]=testlogit()

n = 100000;              % number of draws
gamma = .577215664901;  % Euler's constant

m10 = 0;             % mean utility for outside alternative 1
m20 = 0;             % mean utility for outside alternative 2
m1 = -3;            % mean utility for choice 1
m2 = -3;            % mean utility for choice 2
delta = 7;          % increment to utility if buy both

epsilon10 = -log(log(1./rand(n,1)))-gamma;
epsilon20 = -log(log(1./rand(n,1)))-gamma;
epsilon1 = -log(log(1./rand(n,1)))-gamma;
epsilon2 = -log(log(1./rand(n,1)))-gamma;

%u0 = m0+epsilon0;
u1 = m1+epsilon1-epsilon10;
u2 = m2+epsilon2-epsilon20;
u12 = u1+u2 + delta;

%U = [u0 u1 u2 u12];
U = [zeros(n,1) u1 u2 u12];
[m I]=max(U');

dist=zeros(1,4);

for i = 1:n
    dist(I(i))=dist(I(i))+1;
end

dist = dist./n;