%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% MEXALL.M: Function to compile mex files.
%
% Matthew Gentzkow
% Online Editions
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% path for .c files
sourcepath = 'build/analysis/gentzkow_2007/replication/n_1/c files/source';

% path for include files
C1 = '-I../include'; 

% path for output files
C2 = '-outdir';
C3 = '../mex';

% compile
cd(sourcepath)
calc = 'oedcalc.c';
prob = 'oedcalcprob.c';
tools = 'oedtools.c';
big = 'oedcalcbig.c';
mex('utilities.c', calc, C1, C2, C3)
mex('probabilities1.c', calc, prob, tools, C1, C2, C3)
mex('probabilities7.c', calc, prob, tools, C1, C2, C3)
mex('isdraws.c',        calc, prob, tools, C1, C2, C3, '-g')
mex('gradients.c',      calc, prob, tools, C1, C2, C3)
mex('deltamat.c',       calc, prob, tools, C1, C2, C3)
mex('crossderiv.c',     calc, prob, tools, C1, C2, C3)
mex('likelihood7.c',    calc, prob, big, 'oedobjectives.c', C1, C2, C3)
mex('likelihood1.c',    calc, prob, big, 'oedobjectives.c', C1, C2, C3) 
mex('getcparameters.c', calc, prob, C1, C2, C3)
mex('deltamat1.c',      calc, prob, tools, C1, C2, C3)
mex('crossderivw.c',    calc, prob, tools, C1, C2, C3)

clear sourcepath C1 C2 C3;

exit 
