%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% SETPARAMETERS.M: Script for setting estimation parameters.
%
% Matthew Gentzkow
% July 15, 2003
% Online Editions
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [ImpSamp,tolf0,tolff,tolx0,tolxf,mfe0,mfef,miter0,miterf,m0,...
            mis,msteps,mf,mtest,msee,melast] = setestparams()          

% PROGRAM CONTROLS
ImpSamp = 1;       		% dummy indicating whether to use importance sampling estimator
                        % note that importance sampling should always be
                        % off for no-dynamics estimator

% OPTIMIZATION PARAMETERS
tolf0 = 5e-4;        	% tolerance values for optimization
tolff = 1e-4;
tolx0 = 1e-4;
tolxf = 1e-5;
mfe0 = 1500;       	% max function evaluations for optimization
mfef = 3000;
miter0 = 400;
miterf = 800;

% SIMULATION DRAWS
m0 = 50;                 % number of simulation draws for preliminary parameter estimate
mis = 200;                % number of simulation draws for probs in imp-sampling weights
msteps = [];            % sim draws in steps toward final estimator
mf = 300; 				% final number of simulation draws for parameter estimates
mtest = 50;			    % number of draws to use in calculating bias test statistic
msee  = 30;				% draws for data analysis
melast = 500;			% draws for calculating cross-elasticities

