% Matthew Gentzkow
% February 14, 2002
%
% function chooseone
%
% Simulates choices among alternatives given specified probabilities.
% Takes as input a matrix whose columns represent different choices and whose elements are probabilities
% of each choice for a given row. Note that all rows must sum to 1. Output is a vector of choices for a given
% simulation run.

function choices = chooseone(probmat)

s = size(probmat);
n = s(1);		% number of rows
c = s(2);		% number of choices

P = cumsum(probmat,2);
draw = repmat(rand(n,1),1,c);
testmat = max(0,sign(draw-P));
choices = sum(testmat,2)+1;