% Matthew Gentzkow
% February 23, 2002
%
% function logitsim
%
% Generates data for using a given covariance matrix, then
% simulates logit choices for a given parameter vector. 

function [Y,X] = logitsim()

d = 0;			% number of unobservables
k = 1;			% number of observables
c = 2;			% number of choices
n = 10;  		% number of consumers

S = eye(k);		% covariance of X variables
  
b = [2];		% true parameters (vars in rows (k+d), choices in cols (c-1))
  
b = reshape(b,(k+d)*(c-1),1);
draws = randn(n,k);
X = (S^.5*draws')';
if d>0
   N = randn(n,d);
   DATA = [X N];
else
   DATA = X;
end

% generate matrix of probabilities
bmat = reshape(b,(k+d),c-1);
U = [zeros(n,1) DATA*bmat];				% Add vector of zeros for choice 0
Ue = exp(U);
Ue_sum = repmat(sum(Ue,2),1,c);
P = Ue./Ue_sum;

% simulate YY
YY = simulate(P,1);

% reshape YY as dummy vars
Y = zeros(n,c);
for i = 1:c
   for j = 1:n
      if YY(j)==i, Y(j,i)=1; end
   end
end

  

