%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% GENRESULT.M: Generate RESULT matrix.
%
% Matthew Gentzkow
% July 17, 2003
% Online Editions
%
% note: a*b*c in dimension means vectors stacked as a groups of b groups of c
%
% INPUTS:
%	header		KK+DD					array of variable names
%	bstar		PP					parameter vector
%	SE			PP					vector of standard errors
%
%	
% OUTPUTS:
%	RESULT		PP x 3				nice matrix
%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function RESULT = genresult(header,bstar,SE)

global PP KK DD CC

RESULT = cell(PP,3);
RESULT(1:(CC-1)*(KK+DD),1) = repmat(header,CC-1,1);
RESULT(PP,1) = {'PI'};
RESULT(:,2)=num2cell(bstar);
RESULT(:,3)=num2cell(SE);
RESULT