MODULE proglo
IMPLICIT NONE

SAVE
integer, parameter :: ikind=selected_real_kind(p=15)
integer, parameter :: nschool=12 !maximum schooling levels in sample( no school =1)
integer, parameter :: final=18 !final age for education (no choice there)
integer, parameter :: maxworklife=40  !number of years of working life from 18
integer, parameter :: maxgrade=13 ! maximum grade attainable. NO education is grade 1
integer, parameter :: iprim=6 ! years of primary
!  we start the grant at no education: the first element must always be zero
REAL(ikind), DIMENSION(maxgrade), PARAMETER:: &
& rgrant=(/ 0., 0., 0. , 70., 80., 100., 135., 200., 210., 220., 0., 0., 0.0  /)

!REAL(ikind), DIMENSION(maxgrade), PARAMETER:: &
!& rgrant=(/ 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.  /)
!REAL(ikind), DIMENSION(maxgrade), PARAMETER:: &
!& rgrant=(/ 0., 0., 0., 0., 70., 80., 100., 135., 200., 210., 220., 0., 0.  /)

REAL(ikind), DIMENSION(maxgrade), PARAMETER:: &
& dgrant=(/ 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.  /)

REAL(ikind), DIMENSION(maxgrade), PARAMETER:: &
& ngrant=(/ 0., 0., 0., 0., 0., 0., 0., 700., 700., 700., 0., 0., 0.  /)

real*8,dimension(maxgrade) :: grant

! the matrix tramx contains the probability of passing each grade
! by age
real*8,dimension(maxgrade-1,final-6) :: tramx

!integer, parameter :: nprim=2 ! variables on the cost of primary
!integer, parameter :: nsec = 2 ! variables on the cost of secondary
!integer, parameter :: nconst= 3 ! variables on cost of school entering all ages
!integer :: npoints,npointi

integer, parameter :: npoints=3
! npoints is the number of popints of support in the unobserved
! heterogeneity term in the intercept
integer, parameter :: npointi=1
! npointi is the number of points of suport in the unobserved
! heterogeneity popint term in the slope (effect of the wage and
! and the grant)
!integer, parameter :: npointe=3
! Number of point of support in education density

integer, parameter :: ndiscfact=1
integer, parameter :: nbetajs=1

integer, parameter :: maxvar= 150 ! max number of variables in dataset
integer, parameter :: maxpar= 150 ! max number of parameters to estimate
integer, parameter :: maxobs= 50000 !max number of obs
integer, parameter :: maxvil=506  ! max number of villages
real*8, parameter :: adhours=1.700 ! annual hours for adults
real*8, parameter :: chhours=1.700 ! annual hours for kids
real*8, parameter :: zero=0.000001
real*8, dimension(final,maxgrade) :: vs, vw
real*8, dimension(maxvil,final,maxgrade) :: wage
real*8, dimension(final,maxgrade) :: cost
real*8, dimension(maxgrade,8) :: wfinal
real*8, dimension(maxgrade,7,npoints,npointi) :: VT
!real*8, dimension(ndiscfact),parameter:: betas=(/0.92, 0.93, 0.94, 0.95, 0.96, 0.97, 0.98/)
real*8, dimension(ndiscfact),parameter:: betas=(/0.96/)
real*8, dimension(nbetajs),parameter:: betadjs=(/ 0.0 /)
!real*8, dimension(ndiscfact),parameter:: betadjs=(/   0.0, 0.3,  0.6, 0.8, 0.9 /)
!real*8, dimension(ndiscfact),parameter:: betas=(/ 0.8/)
integer estimat
!real*8, dimension(6),parameter:: betas=(/ 0., 0.1, 0.3,0.5, 0.7, 0.9 /)
real*8 xpoint(npoints)
real*8 xpointi(npointi), xpointe(npoints)
real*8 probp(npoints,npointi)
real*8 cutoff(final,nschool)
real*8, dimension(maxobs,maxpar) :: x, score
real*8, dimension(maxvar) :: tempx
real*8, dimension(maxvil,maxvar) :: xv
real*8, dimension(maxpar) :: theta0
real*8, dimension(maxpar) :: pt  !parameters in terminal value function
!<gslab add in two identifiers family_id, birth_order>
integer, dimension(maxobs):: family_id,birth_order,enrol,age,grade,village,benef,fben,estado, progresa
integer nobs, nvars, nconst, nprim, nsec, npose,nposa,nposg,nvil,  &
 & nvilvar, nvilchi,nparam, npb, useage, progin, useyrs, lowerage, iflag,&
 & useg_a,cons_gr, nyrscp ,nnpb, nparterm,nestado,imode, selage, deriva, npeduc, ncuts, notreat
!notreat = 1 if we are excluding treatment group
integer, dimension(maxvar)::nposc, nposp, nposs, nposeducv, nposeduci
real*8,dimension(maxobs,maxvar):: xprim,xsec,xconst, xeduc
real*8 lz1, lz, beta,betadj
real*8, dimension(8):: retp,retpcom,rets,retscom



ENDMODULE
