subroutine eval(theta)
use proglo
use paramglo
implicit none
real*8, dimension(maxpar) :: theta
real*8, dimension(maxvil,final,nschool) :: dwage
real*8, dimension(maxobs,14)::probi
real*8, dimension(maxobs)::oxsec
real*8, dimension(maxvil,final,maxgrade) :: wage_ge
real*8, dimension(maxvil) :: partv, partv_nogrant, partv_old

integer, dimension(maxvil) :: progresavillage, nv

integer i,j,ii, iter, jk, nb
integer mode, n,nstate, nn1
real*8 f, expend, nexpend, discrep, discrep_part, wageeffect, sum1, part_grant,part_nogrant, part_nogrant_GE, part_newgrant_GE, logw, betao, ss1, wagen
integer:: iuser(1)
real(kind=ikind):: user(1)
!real(kind=ikind),intent(in)::param(:)
real*8 objgrad(1),t2,t4

write(6,*) 'flag  In eval'
do i=1,nparam

    write(6,*) i, theta(i)

enddo
 

! DISCOUNT FACTOR CHANGED MANUALLY AT SEVERAL PLACES IN THIS PROGRAMME

betao = 0.96
beta = betao

!Elasticity of wage with respect to the grant

wageeffect = 2.0


do i=1,maxvil
    do j=1,final
        do ii=1,nschool

            dwage(i,j,ii)= wage(i,j,ii)

        enddo 
    enddo
enddo

! Capture progresa villages **********
do i= 1,maxvil
   progresavillage(i) = 0
   partv(i) = 0.
   partv_old(i) = 0.
   partv_nogrant(i) = 0.
   nv(i) = 0
enddo

do i=1,nobs   
    if ( progresa(i) .eq. 1 )progresavillage(village(i)) = 1
enddo
! *********************

! Actual Grant
grant = rgrant
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f




! Calculating the cost of the Programme and participation
expend = 0
sum1 = 0
do i=1,nobs
    probi(i,1)=probab(i)
    expend = expend + probi(i,1)*benef(i)*rgrant(grade(i))
    sum1 = sum1 + probab(i)
enddo
part_grant = sum1/nobs


! No Grant (ignoring GE effects)
grant = dgrant
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)

sum1=0
do i=1,nobs
    probi(i,2)=probab(i)
    sum1 = sum1 + probab(i)
enddo
part_nogrant = sum1/nobs


! Effect of new grant - no GE effect. 
grant = ngrant
iter = 0
discrep=1.0
write(6,'(a,f8.2)') ' discrep ', discrep

do while (abs(discrep)>0.01)
   write(6,1200) ' n iteration discrep grant ', n, iter, discrep, grant
   call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
   nexpend = 0
   do i=1,nobs
        nexpend = nexpend + probab(i)*benef(i)*grant(grade(i))
   enddo
   discrep = (expend - nexpend)/expend 
   grant = grant*(1+discrep)
   iter = iter+1
   if (iter>10) goto 1234
enddo
1234 continue

do i=1,nobs
    probi(i,3)=probab(i)
enddo

!Switching off the discount factor
beta = 0.

grant = rgrant
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f
do i=1,nobs
   probi(i,4)=probab(i)
enddo

grant = dgrant
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)

do i=1,nobs
    probi(i,5)=probab(i)
enddo

grant = ngrant
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)

do i=1,nobs
    probi(i,6)=probab(i)
enddo

!Switching off uncertainty NO MORE!!!!

! Reducing the wage to the equivalent to the amount of the grant

beta = betao ! discount factor switched back on from 0

do i=1,maxvil
    do j=1,final
        do ii=1,nschool

            wage(i,j,ii)= 0.56*dwage(i,j,ii)

        enddo 
    enddo
enddo
!do ii=1,nschool-1
!do j=1,final-6
!     tramx(ii,j)=1.D0        
!enddo
!enddo

!write(6,*) ' tramx overwritten '
write(6,*) 'wage overwriten'
grant = rgrant 
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f
do i=1,nobs
    probi(i,7)=probab(i)
enddo

!write(6,*) ' tramx overwritten and done 1'

grant = dgrant ! using no grant as the baseline
write(6,*) ' flag3', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)

!write(6,*) ' tramx overwritten and done 2'

do i=1,nobs
    probi(i,8)=probab(i)
enddo

grant=rgrant

do i=1,maxvil
    do j=1,final
        do ii=1,nschool

            wage(i,j,ii)= dwage(i,j,ii)

        enddo 
    enddo
enddo

t2=theta(2)
t4=theta(4)
theta(2)=theta(3)
theta(4)=theta(3)

call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f
do i=1,nobs
    probi(i,11)=probab(i)
enddo 


grant= dgrant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f
do i=1,nobs
    probi(i,12)=probab(i)
enddo 

theta(2)=t2
theta(4)=t4
grant=rgrant

do i=1,nobs
    oxsec(i)=xsec(i,1)
    if (xsec(i,1).ge.3) xsec(i,1)=3
enddo 
!write(6,*) ' tramx overwritten and done 3'

call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f
do i=1,nobs
    probi(i,9)=probab(i)
enddo 

grant=dgrant

call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
write(6,*) ' out of likel, likelihood' , f
do i=1,nobs
    probi(i,10)=probab(i)

enddo 


do i=1,nobs
    xsec(i,1)=oxsec(i)
enddo

!beta=0.
!grant = rgrant
!call likfun(theta)
!do i=1,nobs
!probi(i,3)=probab(i)
!enddo

!grant = dgrant
!call likfun(theta)
!do i=1,nobs
!probi(i,4)=probab(i)
!enddo

    

! No Grant (and allowing for the GE effect )

! Adjust the wage for the removal of the grant

do i=1,maxvil
    do j=1,final
        do ii=1,nschool
            if (progresavillage(i) .eq. 1) wage(i,j,ii)= 0.9418*dwage(i,j,ii)
        enddo 
    enddo
enddo
    
grant = dgrant
write(6,1201) ' n grant ', n, grant
call likel(mode, n, theta, f, objgrad, nstate, iuser, user)

sum1=0
nb = 0
do i=1,nobs
    probi(i,14)=probab(i)
    if (benef(i) .eq. 1) then
        sum1 = sum1 + probab(i)
        nb = nb + 1
    endif
    partv_nogrant(village(i)) = partv_nogrant(village(i)) + probab(i)
    nv(village(i)) = nv(village(i)) + 1
enddo

part_nogrant_GE = sum1/nb

do i=1,maxvil

   if ( nv(i).gt. 0 ) partv_nogrant(i) = partv_nogrant(i)/nv(i)
   partv(i) = partv_nogrant(i)
 !  write(*,'(3i8,f 9.4)') i, progresavillage(i), nv(i), partv_nogrant(i)
enddo


   ! Restore the wage 
    do i=1,maxvil
        do j=1,final
            do ii=1,nschool
                wage(i,j,ii)= dwage(i,j,ii)
            enddo 
        enddo
    enddo
    

!******** effect of new grant - GE

grant = ngrant
iter = 0
discrep=1.0
discrep_part = 1.0
ss1 = 0
nn1 = 0

!write(*,*) iter, discrep, discrep_part

do while (abs(discrep)>0.001 .or. abs(discrep_part)>0.001)

    nn1 = 0
    ss1 = 0
    do j=1,maxvil
        partv_old(j) = partv(j)
        ss1 = ss1 + partv(j)
        nn1 = nn1 + 1
        partv(j) = 0
    enddo
        
        !write(*,*) ss1/nn1, nn1
        
    write(6,1200) ' n iteration discrep grant ', n, iter, discrep, grant
    call likel(mode, n, theta, f, objgrad, nstate, iuser, user)
    nexpend = 0
    sum1 = 0
    nb = 0
    do i=1,nobs
         nexpend = nexpend + probab(i)*benef(i)*grant(grade(i))
         if (benef(i) .eq. 1) then
            sum1 = sum1 + probab(i)
            nb = nb + 1
         endif
         partv(village(i)) = partv(village(i)) + probab(i)
    enddo
    
    part_newgrant_GE = sum1/nb
    discrep_part = 0.0
    do j=1,maxvil
        if (nv(j) .gt. 0) partv(j) = partv(j)/nv(j)
        discrep_part = discrep_part + ( partv(j)- partv_old(j) )**2
    enddo
    
    discrep_part = discrep_part**0.5 
    discrep = (expend - nexpend)/expend 

    grant = grant*(1+discrep)

! adjust the wage
    do i=1,maxvil
        do j=1,final
            do ii=1,nschool
                !wage elasticity with respect to the grant set at the start of the programme
                ! Adjusting the wage relative to value after the reform
                wagen = 0.9418*dwage(i,j,ii)*exp( ( partv(i) - partv_nogrant(i) )*wageeffect )
                if (progresavillage(i) .eq. 1) wage(i,j,ii)= wagen
            enddo 
        enddo
    enddo
    
    
    
    iter = iter+1
    write(*,*) iter, discrep, discrep_part
    if (iter>40) goto 12345

enddo
12345 continue

do i=1,nobs
    probi(i,13)=probab(i)
enddo
!********



   ! Restore the wage and keep old wage
    do i=1,maxvil
        do j=1,final
            do ii=1,nschool
                wage_ge(i,j,ii) = wage(i,j,ii)
                wage(i,j,ii)= dwage(i,j,ii)
            enddo 
        enddo
    enddo
    
write (6, * ) 'Discount factor ' , beta

!open(33,file='dumpawage.out', status='new')
do i=1,nobs
    !write(77,100) age(i), benef(i), fben(i), grade(i), enrol(i), progresa(i), (probi(i,j),j=1,8)
    write(77,100) age(i), benef(i), fben(i), grade(i), enrol(i), progresa(i) , wage(village(i),age(i)-5,grade(i)), wage_ge(village(i),age(i)-5,grade(i)),  (xconst(i,jk),jk=2,7),xsec(i,1),(probi(i,j),j=1,14)
    !write(33,'(3i5,f12.5)') village(i),age(i),grade(i), wage(village(i),age(i),grade(i))
enddo


write(6,*) 'done'
100 format(6i6,7f11.3, 16f13.6)
1200 format(a, 2i4,15f7.1)
1201 format(a, 1i4,16f7.1)


return 
end


