% test MEX functions

% this test file uses the following parameter values:
% NN 3
% GG 2
% CC 4
% KK 2
% DD 1
% PMAX 12
% PP 11
% ZZ 10
% CCW 9

clear all
load data4test

m = 2;
ninput = 3;

% test utilities.c
U = utilities(b,excl,X,RD,CM,m,ninput);
if U==Utrue
	'utilities.c test passed'
else
	[U Utrue]
	error('utilities.c test failed');
end

% test probabilities1.c
P1 = probabilities1(X,RD,b,excl,CM,m,ninput);
if abs(P1-P1true)<10^-10
	'probabilities1.c test passed'
else
	[P1 P1true]
	error('probabilities1.c test failed');
end

% test probabilities7.c
P7 = probabilities7(X,Y1,Y7,RD,b,excl,CM,Bcons,Bex,m,ninput);
if abs(P7-P7true)<10^-10
	'probabilities7.c test passed'
else
	[P7 P7true]
	error('probabilities7.c test failed');
end

% test isdraws.c
[P0,RDis] = isdraws(b,excl,m,Y1,Y7,X,CM,Bcons,Bex, IJseed, KLseed);
if abs(P0-P0true)<10^-10
	'isdraws.c test passed'
else
	[P0 P0true]
	error('isdraws.c test failed');
end

% test  crossderiv.c
CD = crossderiv(b,excl,m,ninput,X,RD,CM);
if abs(CD-CDtrue)<10^-10
	'crossderiv.c test passed'
else
	[CD CDtrue]
	error('crossderiv.c test failed');
end

% test  gradients.c
G = gradients(b,excl,Y1,Y7,X,RD,CM,Bcons,Bex,weights,m);
if abs(G-Gtrue)<10^-3
	'gradients.c test passed'
else
	[G Gtrue]
	error('gradients.c test failed');
end

% test  deltamat.c
DM = deltamat(b,excl,m,X,RD,CM,Bcons,Bex,weights,Y1,Y7);
if abs(DM-DMtrue)<10^-3
	'deltamat.c test passed'
else
	[DM DMtrue]
	error('deltamat.c test failed');
end

% test  likelihood1.c
[L dLc] = likelihood1(bc,m,excl,Y1,Y7,X,RD,CM,Bcons,Bex,T,A,weights);
if abs(L-Ltrue)<10^(-3) & abs(dLc-dLctrue)<10^(-3)
	'likelihood1.c test passed'
else
	[L Ltrue]
    [dLc dLctrue]
	error('likelihood1.c test failed');
end

% test  likelihood7.c
[L dLc] = likelihood7(bc,m,excl,Y1,Y7,X,RD,CM,Bcons,Bex,T,A,weights);
if abs(L-L7true)<10^(-3) & abs(dLc-dLc7true)<10^(-3)
	'likelihood7.c test passed'
else
	[L L7true]
    [dLc dL7ctrue]
	error('likelihood7.c test failed');
end





% % test  msmobj.c
% [Gn,dGn] = msmobj(bc,excl,Z,Y1,Y7,Cdum,X,RD,weights,T,A,CM,Cincl,Bcons,Mcons,Mincl,Bex,m);
% if abs(Gn-Gntrue)<10^(-10) & abs(dGn-dGntrue)<10^(-10)
% 	'msmobj.c test passed'
% else
% 	[Gn Gntrue]
%     [dGn dGntrue]
% 	error('msmobj.c test failed');
% end
% 
% 
% % test probabilities.c
% P = probabilities(X,RD,b,excl,CM,m);
% if abs(P-Ptrue)<10^-10
% 	'probabilities.c test passed'
% else
% 	[P Ptrue]
% 	error('probabilities.c test failed');
% end
% 
% % test probabilitiesall.c
% Pall = probabilitiesall(X,RD,b,excl,CM,m,ninput);
% if abs(Pall-Palltrue)<10^-10
% 	'probabilitiesall.c test passed'
% else
% 	[Pall Palltrue]
% 	error('probabilitiesall.c test failed');
% end
% 
% % test avgprob.c
% Pavg0 = avgprob(b,excl,m,Y1,Y7,X,RD,CM,Bcons,Bex);
% if abs(Pavg0-Pavg0true)<10^-10
% 	'avgprob.c test passed'
% else
% 	[Pavg0 Pavg0true]
% 	error('avgprob.c test failed');
% end

% test calc7big.c
% P7big = calc7big(b,excl,Y1,Y7,X,RD,weights,CM,Cincl,Bcons,Mcons,Mincl,Bex,m);
% [P7big dP7big] = calc7big(b,excl,Y1,Y7,X,RD,weights,CM,Cincl,Bcons,Mcons,Mincl,Bex,m);
% if min(min(P7big==P7bigtrue)) & min(min(dP7big==dP7bigtrue))
% 	'calc7big.c test passed'
% else
% 	[P7big P7bigtrue]
%     [dP7big dP7bigtrue]
% 	error('calc7big.c test failed');
% end

