function table 
% Write sensitivities and sufficiencies tables using informativeness_results.mat
    echo on
    diary off
    clear

    %% Add path
    addpath('source/lib/YAMLMatlab_0.4.3')
    PATHS = ReadYaml('config_global.yaml');
    load(sprintf('%s/informativeness_results.mat', PATHS.build.analysis.hendren_2013))
  
    %% Store informativeness
    table_path = sprintf('%s/hendren_informativeness.tsv', PATHS.build.analysis.hendren_2013);
    fid = fopen(table_path, 'w'); 
    fprintf(fid, '<tab:hendren_informativeness>\n');
    fprintf(fid, '%.4f\n', [cf{5}]); 
    fprintf(fid, '%.4f\n', [cf{1}]);  
    fprintf(fid, '%.4f\n', [cf{2}]); 
    fprintf(fid, '%.4f\n', [cf{3}]); 
    fclose(fid);                            

    %% Store SEs calculated by Sigma to check with published ones
    % get published (lb, ub) for minimum pooled price ratio 
    fid = fopen(sprintf('%s/orig/published_mppr_CI.csv', PATHS.build.external.hendren_2013));
    published_results = textscan(fid, '%s%f%f%f', 'Headerlines', 1, 'Delimiter', ',');
    fclose(fid);    
    published_ub = published_results{4};
    published_lb = published_results{3};
    published_est = published_results{2};
    
    % get implied (lb, ub) for minimum pooled price ratio 
    ub = published_est + 1.96 * se;
    lb = published_est - 1.96 * se;
    
    % Write check-se to file
    table_path = sprintf('%s/hendren_se_check.tsv', PATHS.build.analysis.hendren_2013);
    fid = fopen(table_path, 'w'); 
    fprintf(fid, '<tab:hendren_se_check>\n');
    fprintf(fid, '(%.4f, %.4f) \t (%.4f, %.4f)\n', [lb; ub; published_lb; published_ub]);  
    fclose(fid);                            

    exit
end


